
local Map = {} -- Map object


function Map:reload()
    Map = {}
end

Map.MAP = {}
Map.heightmap = {}
Map.Img_Tiles = {}
Map.mountainscale = 0
Map.random = love.math.random(0, 1000)/1000
Map.h = 0 -- for the mouse
-- Tiles name

Map.height_val = 10
Map.wandh = {55, 35} -- map's width and height

Map.Img_Tiles[1] = love.graphics.newImage("assets/tiles/tile1.png", {mipmaps = true})
Map.Img_Tiles[2] = love.graphics.newImage("assets/tiles/tile2.png", {mipmaps = true})
Map.Img_Tiles[3] = love.graphics.newImage("assets/tiles/tile3.png", {mipmaps = true})
Map.Img_Tiles[4] = love.graphics.newImage("assets/tiles/tile3.png", {mipmaps = true})
    
    for i = Map.wandh[1], 1, -1 do
        Map.MAP[i] = {}
        for j = Map.wandh[2], 1, -1 do
            Map.MAP[i][j] = 2  -- creates a map
        end
    end     
    for i = Map.wandh[1], 1, -1 do
        Map.heightmap[i] = {}
        for j = Map.wandh[2], 1, -1 do
            local nx = i/Map.wandh[1] + Map.random
            local ny = j/Map.wandh[2] + Map.random
            Map.heightmap[i][j] =  math.pow(Map.height_val - (Map.height_val*  (love.math.noise( nx * Map.mountainscale/1.3, ny * Map.mountainscale))), 1)--  to give the mountain a certain shape
           
            -- rules
            
           if math.floor(Map.heightmap[i][j]) <= 1 then  Map.heightmap[i][j] = 1 Map.MAP[i][j] = 3  end
           if math.floor(Map.heightmap[i][j]) == 2 then  Map.heightmap[i][j] = 2 Map.MAP[i][j] = 3  end
           if math.floor(Map.heightmap[i][j]) == 3 then  Map.heightmap[i][j] = 3 Map.MAP[i][j] = 3 end
           if math.floor(Map.heightmap[i][j]) == 4 then  Map.heightmap[i][j] = 4 Map.MAP[i][j] = 3 end
           if math.floor(Map.heightmap[i][j]) == 5 then  Map.heightmap[i][j] = 5 Map.MAP[i][j] = 1  end
           if math.floor(Map.heightmap[i][j]) == 6 then  Map.heightmap[i][j] = 6 Map.MAP[i][j] = 1  end
           if math.floor(Map.heightmap[i][j]) == 7 then  Map.heightmap[i][j] = 7 Map.MAP[i][j] = 1  end
           if math.floor(Map.heightmap[i][j]) == 8 then  Map.heightmap[i][j] = 8 Map.MAP[i][j] = 2 end
           if math.floor(Map.heightmap[i][j]) == 9 then  Map.heightmap[i][j] = 9 Map.MAP[i][j] = 2 end
           if math.floor(Map.heightmap[i][j]) > Map.height_val then  Map.heightmap[i][j] = Map.height_val Map.MAP[i][j] = 2  end
        end
    end
    
local line, column, num, height, height_size, color_contrast, edge, color, alpha 

function Map.update()
    
end
function Map:draw(camera, tile_size)
    
    for line =1, Map.wandh[1] do -- does the line/column grid thing
        for column =1, Map.wandh[2] do
            
            num = Map.MAP[line][column]
            height = Map.heightmap[line][column]
            
            color_contrast = 1 + (Map.height_val * 0.095)  -- is the value for the color of the map.
            
            edge = tile_size[2]/2
            color = Map.height_val* 2 - color_contrast * Map.height_val -- color value(2 to lower the contrast)
            
            if num > 0 then
            local x =  (column - line)* tile_size[1]/2
            local y =  (column+1 + line+1)* tile_size[2]/2
                 -- draws the map according to the tiles and camera position
                
                for height_size = 1, height do -- draws a the height according to the height map
                    local color_result = ((color + (height - 1) *  color_contrast)/10)
                    
              love.graphics.setColor(color_result, color_result, color_result)-- sets a color according to height
                    
                if player.validMove[tostring(line .. ":" .. column)] ~= nil then
                        love.graphics.setColor(0.3, 0.25, 1)
                        love.graphics.draw(Map.Img_Tiles[num], x + camera.x, (y - height_size * edge) + camera.y, 0, 1/camera.scale)
                        love.graphics.setColor(1, 1, 1)
                else    
                    love.graphics.draw(Map.Img_Tiles[num], x + camera.x, (y - height_size * edge) + camera.y, 0, 1/camera.scale)
                end
                    
              --love.graphics.print(num, x + camera.x, (y - height_size * edge) + camera.y, 0, 1/camera.scale)-- for debug
                love.graphics.setColor(255, 255, 255)
                end
            end
        end
    end
end

return Map