local player = require("character")

player:load(1, 1, 1)
player.spd = 1
player.h = 1
player.size = {27, 36}
player.clickedon = false
player.idle = love.graphics.newImage("assets/player.png")
player.anim = {love.graphics.newImage("assets/player2.png"), love.graphics.newImage("assets/player3.png")} 
player.animval = 0 -- used to animate the player
player.animlimit = #player.anim
player.spr = player.anim[1]
player.fx = 0 --the final y where its going to be drawn
player.fy = 0 --the final y where its going to be drawn
differential = 2 -- used to map the player as the same tile at the map.

function player.resetValidMove()
	player.validMove = {}
end


function player.ValidSpaces(x, y, movement, moveMax)
    local mapW = Map.wandh[2]
    local mapH =  Map.wandh[1]
    
	if (movement > moveMax) or (x > mapW) or (x < 0) or (y < 0) or (y > mapH) then
		return false
	end 
    
    local key = tostring(x..':'..y)
    if player.validMove[key] == nil or player.validMove[key] > movement then
		player.validMove[key] = movement
		return
			player.ValidSpaces(x+1, y, movement + 1, moveMax), -- Check right
			player.ValidSpaces(x - 1, y, movement + 1, moveMax), -- check left
			player.ValidSpaces(x, y+1, movement + 1, moveMax), -- check down
			player.ValidSpaces(x, y - 1, movement + 1, moveMax)  -- check up
	end
end


if player.active then
    
    --UPDATE
    function player:update()
      print(player.validMove[1])
        
      player.spr = player.idle  
      player.h = Map.heightmap[player.y + differential][player.x + differential] -- the +1 is to correspond to these values
        
    if player.clickedon then --and  player.validMove[tostring(mouse.maptile.x .. ":" .. mouse.maptile.y)] ~= nil then
        if love.mouse.isDown(1) then
        player.x = mouse.maptile.x - 2
        player.y = mouse.maptile.y - 2
        player.resetValidMove()
        player.clickedon = false
        end
    end
        
    end
    
    
    -- DRAW
    function player:draw()

        local x =  (player.x - player.y)* tile_size[1]/2
        local y =  (player.x+1 + player.y+1)* tile_size[2]/2
        if player.clickedon then
            love.graphics.setColor(1, 0, 0.5)
        else
            love.graphics.setColor(1, 1, 1)
        end
        love.graphics.draw(player.spr, x + camera.x,  (y - (player.h - differential) * tile_size[2]/2) + camera.y, 0, 1/camera.scale) -- draws the camera exactly like in the map7
        player.rx =  x + camera.x
        player.ry = (y - (player.h - differential) * tile_size[2]/2) + camera.y
        
        love.graphics.rectangle("line", player.rx, player.ry, player.size[1], player.size[2]) -- debug
        
        love.graphics.setColor(1, 1, 1)
    end
end


return player